/* SPDX-License-Identifier: GPL-3.0-or-later */
/* Copyright (C) 2021 KikooDX */
#pragma once

#include <raylib.h> /* for the color struct */

#define TILE_WIDTH  16
#define TILE_HEIGHT 16
#define TILE_FIRST  0

#define EDITOR_BACKGROUND_COLOR                                        \
	(Color) { 0, 0, 0, 255 }
#define PICKER_BACKGROUND_COLOR                                        \
	(Color) { 0, 0, 0, 255 }
#define UNSELECTED_TILE_COLOR                                          \
	(Color) { 80, 80, 80, 255 }
#define OVERRING_TILE_COLOR                                            \
	(Color) { 255, 255, 255, 80 }

#define NEW_LEVEL_WIDTH  25
#define NEW_LEVEL_HEIGHT 14

#define EDITOR_WINDOW_WIDTH  396
#define EDITOR_WINDOW_HEIGHT 224
#define EDITOR_TARGET_FPS    60
#define EDITOR_DRAW_OFFSET_X -2
#define EDITOR_DRAW_OFFSET_Y 0

#define PICKER_TARGET_FPS 30
#define PICKER_PADDING    4

#define PICKER_WINDOW_WIDTH                                            \
	((TILE_WIDTH + PICKER_PADDING) * TILESET_WIDTH + PICKER_PADDING)
#define PICKER_WINDOW_HEIGHT                                           \
	((TILE_HEIGHT + PICKER_PADDING) * TILESET_HEIGHT +             \
	 PICKER_PADDING)
