/* SPDX-License-Identifier: GPL-3.0-or-later */
/* Copyright (C) 2021 KikooDX */
#pragma once

#include <raylib.h>

#define BUFFER_SIZE 256

struct Options {
	/* required arguments */
	char tileset_path[BUFFER_SIZE];
	char level_path[BUFFER_SIZE];
	/* optionnal arguments, default values in conf.h */
	int tile_width;
	int tile_height;
	int tile_first;
	int new_level_width;
	int new_level_height;
	int editor_width;
	int editor_height;
	int editor_target_fps;
	int editor_draw_offset_x;
	int editor_draw_offset_y;
	Color editor_bg_color;
	int picker_target_fps;
	int picker_padding;
	Color picker_bg_color;
	/* determined after previous options */
	int tileset_width;
	int tileset_height;
	int picker_window_width;
	int picker_window_height;
	int level_create;
};

struct Options options_defaults(void);
